import QtQuick 2.4
//import QtWebKit 1.0
import ProcessContainer 1.0
import Process 0.1

import ".."
import "../Keypad"

Item{
    id: root
    width:1000
    height:406

    property string url
    property bool keyingURL: false
    property string defaultURL: options.homeURL
    property bool noSwipe: true
    property int currentContentWidth:0
    property bool hasBeenShown: false

    function viewdestruct() {
        console.log("viewdestruct called! (WebViewContainer.qml)")
        browserProcess.kill()
        flashWatcher.kill()
        html5watcher.kill()
        root.url = ""
    }

    function shown() {
        root.hasBeenShown = true
        browserProcess.write("CMD shown\n")
        if (flashWatcher.soundIsPlaying || html5watcher.soundIsPlaying)
            audioManager.flashRequest()
    }

    function hidden() {
        browserProcess.write("CMD hidden\n")
        urlKeypad.process.write("CMD hide\n")
        inputKeypad.process.write("CMD hide\n")
        workoutScreen.browserFullscreen = false
    }

    Connections {
        target: application

        onMainViewFocusChanged: {
            if (isFocused) {
                urlKeypad.process.write("CMD hide\n")
                inputKeypad.process.write("CMD hide\n")
            }
        }
    }

//    ProcessContainer {
//        id: processContainer

//        width: workoutScreen.browserFullscreen ? 1200 : 1000
//        height: workoutScreen.browserFullscreen ? 665 : 406
//        globalX: workoutScreen.browserFullscreen ? 5 : 182
//        globalY: workoutScreen.browserFullscreen ? 100 : 172
//        anchors.top: parent.top
//        visible: true
//        frozen: !visible || workoutViewContainer.currentViewName !== "WEB_VIEW" || workoutViewContainer.isMoving || stopPrompt.visible || dialogManager.anyAreShown || inclineKeyPad.state === "showing" || speedKeyPad.state === "showing"
//        readyForImage: root.hasBeenShown
//        onWinidChanged: {
//            // The browser is ready to embedded
//            console.log("ProcessContainer>> winid is", winid)
//            if (winid > 0) {
//                browserProcess.arguments = ["--winid", winid, "--home-url", options.homeURL, "--language", application.currentLanguage]
//                browserProcess.start()
//                flashWatcher.start()
//                html5watcher.start()
//            }
//        }
//        Component.onCompleted: processContainer.createContainer()
//    }

    Process {
        id: browserProcess
        program: "scripts/start_browser.sh"
        onReadyReadStandardOutput: {
            var data = (String(readAllStandardOutput())).trim()
            console.log("browserprocess:",data)
        }
        onReadyReadStandardError: {
            var data = (String(readAllStandardError())).trim()
            console.log("browserprocess (stderr):",data)
            if (data.indexOf("CMD fullscreen") === 0) {
                workoutScreen.browserFullscreen = !workoutScreen.browserFullscreen
            }
        }
        onFinished: {
            console.log("Restarting browser...")
            restart()
        }
//        Component.onCompleted: start()
    }

}
